// Craig S. Kaplan

// Click to place a random Circle.  Circles are stored in an array
// that grows by one every time you click.  Try modifying the sketch
// so that every circle gets a bit larger on every frame.  The 
// result will look a bit like ripples in a pond.

// Define a small Circle class so that we can track information
// about whole circles.
class Circle
{
  float cx;
  float cy;
  float rad;

  Circle( float cxIn, float cyIn, float radIn )
  {
    cx = cxIn;
    cy = cyIn;
    rad = radIn;
  }

  // Create a method allowing us ask every circle to
  // draw itself.  
  // I renamed this method drawYourself() to make it clear
  // that any connection to the global draw() function was
  // a coincidence.  I named Circle's draw() method the
  // same as the global function simply because they're so
  // closely connected, not based on any sort of requirement.
  void drawYourself()
  {
    ellipse( cx, cy, 2 * rad, 2 * rad );
  }
}

Circle[] circs;

void setup()
{
  size( 500, 500 );
  stroke( 0 );
  noFill();

  circs = new Circle[0];
}

void draw()
{
  background( 255 );
  
  for( int idx = 0; idx < circs.length; ++idx ) {
    circs[idx].drawYourself();
  }
}

void mousePressed()
{
  Circle ncirc = new Circle( mouseX, mouseY, random( 10, 100 ) );
  circs = (Circle[])append( circs, ncirc );
}
